# File generated from our OpenAPI spec by Stainless.

from __future__ import annotations

from typing import TYPE_CHECKING

from ..types import MakeAmbiguousSchemasExplicitMakeAmbiguousSchemasExplicitResponse
from .._types import NOT_GIVEN, Body, Query, Headers, NotGiven
from .._resource import SyncAPIResource, AsyncAPIResource
from .._response import to_raw_response_wrapper, async_to_raw_response_wrapper
from .._base_client import make_request_options

if TYPE_CHECKING:
    from .._client import Sink, AsyncSink

__all__ = ["MakeAmbiguousSchemasExplicit", "AsyncMakeAmbiguousSchemasExplicit"]


class MakeAmbiguousSchemasExplicit(SyncAPIResource):
    with_raw_response: MakeAmbiguousSchemasExplicitWithRawResponse

    def __init__(self, client: Sink) -> None:
        super().__init__(client)
        self.with_raw_response = MakeAmbiguousSchemasExplicitWithRawResponse(self)

    def make_ambiguous_schemas_explicit(
        self,
        *,
        # Use the following arguments if you need to pass additional parameters to the API that aren't available via kwargs.
        # The extra values given here take precedence over values defined on the client or passed to this method.
        extra_headers: Headers | None = None,
        extra_query: Query | None = None,
        extra_body: Body | None = None,
        timeout: float | None | NotGiven = NOT_GIVEN,
    ) -> MakeAmbiguousSchemasExplicitMakeAmbiguousSchemasExplicitResponse:
        """Test case for makeAmbiguousSchemasExplicit"""
        return self._get(
            "/make-ambiguous-schemas-explicit",
            options=make_request_options(
                extra_headers=extra_headers, extra_query=extra_query, extra_body=extra_body, timeout=timeout
            ),
            cast_to=MakeAmbiguousSchemasExplicitMakeAmbiguousSchemasExplicitResponse,
        )


class AsyncMakeAmbiguousSchemasExplicit(AsyncAPIResource):
    with_raw_response: AsyncMakeAmbiguousSchemasExplicitWithRawResponse

    def __init__(self, client: AsyncSink) -> None:
        super().__init__(client)
        self.with_raw_response = AsyncMakeAmbiguousSchemasExplicitWithRawResponse(self)

    async def make_ambiguous_schemas_explicit(
        self,
        *,
        # Use the following arguments if you need to pass additional parameters to the API that aren't available via kwargs.
        # The extra values given here take precedence over values defined on the client or passed to this method.
        extra_headers: Headers | None = None,
        extra_query: Query | None = None,
        extra_body: Body | None = None,
        timeout: float | None | NotGiven = NOT_GIVEN,
    ) -> MakeAmbiguousSchemasExplicitMakeAmbiguousSchemasExplicitResponse:
        """Test case for makeAmbiguousSchemasExplicit"""
        return await self._get(
            "/make-ambiguous-schemas-explicit",
            options=make_request_options(
                extra_headers=extra_headers, extra_query=extra_query, extra_body=extra_body, timeout=timeout
            ),
            cast_to=MakeAmbiguousSchemasExplicitMakeAmbiguousSchemasExplicitResponse,
        )


class MakeAmbiguousSchemasExplicitWithRawResponse:
    def __init__(self, make_ambiguous_schemas_explicit: MakeAmbiguousSchemasExplicit) -> None:
        self.make_ambiguous_schemas_explicit = to_raw_response_wrapper(
            make_ambiguous_schemas_explicit.make_ambiguous_schemas_explicit,
        )


class AsyncMakeAmbiguousSchemasExplicitWithRawResponse:
    def __init__(self, make_ambiguous_schemas_explicit: AsyncMakeAmbiguousSchemasExplicit) -> None:
        self.make_ambiguous_schemas_explicit = async_to_raw_response_wrapper(
            make_ambiguous_schemas_explicit.make_ambiguous_schemas_explicit,
        )
